| OGRE 1.10.8 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLESProgramPipelineManager Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state. More...

`#include <OgreGLSLESProgramPipelineManager.h>`

Inheritance diagram for Ogre::GLSLESProgramPipelineManager:
[legend]

## Public Member Functions
| GLSLESProgramPipelineManager (void)
| ~GLSLESProgramPipelineManager (void)
GLSLESProgramPipeline * | getActiveProgramPipeline (void)
| Get the program object that links the two active program objects together. More...
void | optimiseShaderSource (GLSLESGpuProgram *gpuProgram)
void | setActiveFragmentLinkProgram (GLSLESProgram *fragmentGpuProgram)
void | setActiveVertexLinkProgram (GLSLESProgram *vertexGpuProgram)
| Set the active vertex and fragment link programs for the next rendering state. More...

## Static Public Member Functions
static void | extractUniforms (GLuint programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &list, GLUniformBufferList &sharedList)
| Populate a list of uniforms based on a program object. More...
static GLSLESProgramPipelineManager & | getSingleton (void)
static GLSLESProgramPipelineManager * | getSingletonPtr (void)

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state.

GLSL vertex and fragment program objects are compiled separately and then attached to a program object and then the program pipeline object is linked. Since Ogre can only handle one vertex program stage and one fragment program stage being active in a pass, the GLSL ES Program Pipeline Manager does the same. The GLSL ES Program Pipeline Manager acts as a state machine and activates a pipeline object based on the active vertex and fragment program. Previously created pipeline objects are stored along with a unique key in a hash_map for quick retrieval the next time the pipeline object is required.

## Constructor & Destructor Documentation

## ◆ GLSLESProgramPipelineManager()

Ogre::GLSLESProgramPipelineManager::GLSLESProgramPipelineManager | ( | void |  | ) |

## ◆ ~GLSLESProgramPipelineManager()

Ogre::GLSLESProgramPipelineManager::~GLSLESProgramPipelineManager | ( | void |  | ) |

## Member Function Documentation

## ◆ getActiveProgramPipeline()

GLSLESProgramPipeline* Ogre::GLSLESProgramPipelineManager::getActiveProgramPipeline | ( | void |  | ) |

Get the program object that links the two active program objects together.

If a program pipeline object was not already created and linked a new one is created and linked.

## ◆ setActiveVertexLinkProgram()

void Ogre::GLSLESProgramPipelineManager::setActiveVertexLinkProgram | ( | GLSLESProgram * | vertexGpuProgram | ) |

Set the active vertex and fragment link programs for the next rendering state.

The active program pipeline object will be cleared. Normally called from the GLSLESGpuProgram::bindProgram and unbindProgram methods

## ◆ setActiveFragmentLinkProgram()

void Ogre::GLSLESProgramPipelineManager::setActiveFragmentLinkProgram | ( | GLSLESProgram * | fragmentGpuProgram | ) |

## ◆ getSingleton()

static GLSLESProgramPipelineManager& Ogre::GLSLESProgramPipelineManager::getSingleton | ( | void |  | ) |
| static

## ◆ getSingletonPtr()

static GLSLESProgramPipelineManager* Ogre::GLSLESProgramPipelineManager::getSingletonPtr | ( | void |  | ) |
| static

## ◆ optimiseShaderSource()

void Ogre::GLSLESProgramManagerCommon::optimiseShaderSource | ( | GLSLESGpuProgram * | gpuProgram | ) |
| inherited

## ◆ extractUniforms()

static void Ogre::GLSLESProgramManagerCommon::extractUniforms | ( | GLuint | programObject,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReferenceList & | list,
|  | GLUniformBufferList & | sharedList
| ) |  |
| static inherited

Populate a list of uniforms based on a program object.

Parameters

  programObject | Handle to the program object to query
  vertexConstantDefs | Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program.
  fragmentConstantDefs | Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program.
  list | The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).

The documentation for this class was generated from the following file:

- OgreGLSLESProgramPipelineManager.h